<?php
/*
 * Copyright 2005-2009 MERETHIS
 * Centreon is developped by : Julien Mathis and Romain Le Merlus under
 * GPL Licence 2.0.
 * 
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the GNU General Public License as published by the Free Software 
 * Foundation ; either version 2 of the License.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, see <http://www.gnu.org/licenses>.
 * 
 * Linking this program statically or dynamically with other modules is making a 
 * combined work based on this program. Thus, the terms and conditions of the GNU 
 * General Public License cover the whole combination.
 * 
 * As a special exception, the copyright holders of this program give MERETHIS 
 * permission to link this program with independent modules to produce an executable, 
 * regardless of the license terms of these independent modules, and to copy and 
 * distribute the resulting executable under terms of MERETHIS choice, provided that 
 * MERETHIS also meet, for each linked independent module, the terms  and conditions 
 * of the license of that module. An independent module is a module which is not 
 * derived from this program. If you modify this program, you may extend this 
 * exception to your version of the program, but you are not obliged to do so. If you
 * do not wish to do so, delete this exception statement from your version.
 * 
 * For more information : contact@centreon.com
 * 
 * Module name: Syslog
 * 
 * Adaptation for Centreon 2.0 by : Merethis team 
 * 
 * SVN : $URL
 * SVN : $Id$
 * 
 */

	include 'DBconnect.php';

	$table_cache_tmp = "temp";
	$table_cache = "cache";
	$merge_cache = "all_cache";

	function createTemporaryTable() {
		global $table_cache_tmp, $pear_syslogDB;
		
		$query = "CREATE TABLE IF NOT EXISTS `".$table_cache_tmp."` (";
		$query = $query." `type` enum('HOST','FACILITY','PROGRAM','PRIORITY', 'TAG') collate utf8_unicode_ci default NULL,";
		$query = $query." `value` varchar(50) collate utf8_unicode_ci default NULL";
		$query = $query." ) ENGINE=MEMORY DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;";

		$pear_syslogDB->query($query);
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}
	}
	
	function instertCache() {
		global $table_cache_tmp, $pear_syslogDB, $syslogOpt;
		
		$query_host = "SELECT distinct(host) as host FROM logs";
		$query_tag = "SELECT distinct(tag) as tag FROM logs";
		$query_facility = "SELECT distinct(facility) as facility FROM logs";
		$query_priority = "SELECT distinct(priority) as priority FROM logs";
		$query_program = "SELECT distinct(program) as program FROM logs";
		
		## HOST
		$res =& $pear_syslogDB->query($query_host);
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}

		if ($res->numRows()){
			while($row = $res->fetchRow()) {
				$pear_syslogDB->query("INSERT INTO ".$table_cache_tmp." (type, value) VALUES('HOST', \"".$row["host"]."\")");
				if (PEAR::isError($pear_syslogDB)) {
					print "Mysql Error : ".$pear_syslogDB->getMessage();
				}
			}
		}
		
		## TAG
		$res =& $pear_syslogDB->query($query_tag);
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}

		if ($res->numRows()){
			while($row = $res->fetchRow()) {
				$pear_syslogDB->query("INSERT INTO ".$table_cache_tmp." (type, value) VALUES('TAG', \"".$row["tag"]."\")");
				if (PEAR::isError($pear_syslogDB)) {
					print "Mysql Error : ".$pear_syslogDB->getMessage();
				}
			}
		}
		
		## FACILITY
		$res =& $pear_syslogDB->query($query_facility);
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}

		if ($res->numRows()){
			while($row = $res->fetchRow()) {
				$pear_syslogDB->query("INSERT INTO ".$table_cache_tmp." (type, value) VALUES('FACILITY', \"".$row["facility"]."\")");
				if (PEAR::isError($pear_syslogDB)) {
					print "Mysql Error : ".$pear_syslogDB->getMessage();
				}
			}
		}
		
		## PRIORITY
		$res =& $pear_syslogDB->query($query_priority);
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}

		if ($res->numRows()){
			while($row = $res->fetchRow()) {
				$pear_syslogDB->query("INSERT INTO ".$table_cache_tmp." (type, value) VALUES('PRIORITY', \"".$row["priority"]."\")");
				if (PEAR::isError($pear_syslogDB)) {
					print "Mysql Error : ".$pear_syslogDB->getMessage();
				}
			}
		}
		
		## PROGRAM
		$res =& $pear_syslogDB->query($query_program);
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}

		if ($res->numRows()){
			while($row = $res->fetchRow()) {
				$pear_syslogDB->query("INSERT INTO ".$table_cache_tmp." (type, value) VALUES('PROGRAM', \"".$row["program"]."\")");
				if (PEAR::isError($pear_syslogDB)) {
					print "Mysql Error : ".$pear_syslogDB->getMessage();
				}
			}
		}
	}
	
	function createCacheTable() {
		global $table_cache, $table_cache_tmp, $merge_cache, $pear_syslogDB, $syslogOpt;

		$query = "DROP TABLE IF EXISTS ".$merge_cache.";";
		$pear_syslogDB->query($query);
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}

		$query = "DROP TABLE IF EXISTS ".$table_cache.";";
		$pear_syslogDB->query($query);
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}
		
		$query = "CREATE TABLE ".$table_cache." AS SELECT * FROM ".$table_cache_tmp.";";
		$pear_syslogDB->query($query);
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}
		
		$query = "DROP TABLE ".$table_cache_tmp;
		$pear_syslogDB->query($query);
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}
	}

	function getCacheTables() {
	  	global $pear_syslogDB, $syslogOpt, $cacheTables;
	
	  	$res =& $pear_syslogDB->query("SHOW TABLES;");
	  	if (PEAR::isError($pear_syslogDB)) {
	    	print "Mysql Error : ".$pear_syslogDB->getMessage();
	  	}
	
	  	if ($res->numRows()){
	    	while($row = $res->fetchRow()) {
	      		if (strstr($row["Tables_in_syslog"], "cache")) {
					$cacheTables[$row["Tables_in_syslog"]] = $row["Tables_in_syslog"];
	      		}
	    	}
	  	}
	  	return $cacheTables;
	}


	function mergeAllCache() {
	  	global $pear_syslogDB, $merge_cache, $table_cache;
	
	  	$query = "DROP TABLE IF EXISTS ".$merge_cache.";";
	  	$pear_syslogDB->query($query);
	  	if (PEAR::isError($pear_syslogDB)) {
	    	print "Mysql Error : ".$pear_syslogDB->getMessage();
	  	}
	  
	  	$mergeTable = "CREATE TABLE $merge_cache (";
	  	$mergeTable = $mergeTable . "`type` enum('HOST','FACILITY','PROGRAM','PRIORITY', 'TAG') collate utf8_unicode_ci default NULL,";
	  	$mergeTable = $mergeTable . "`value` varchar(50) collate utf8_unicode_ci default NULL";
	  	$mergeTable = $mergeTable . ") ENGINE=MRG_MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci UNION=(";
	
	  	$CacheTables = getCacheTables();
	
	  	foreach ($CacheTables as $CacheTable) {
	   		if (strcmp($CacheTable, "cache") > 0) {
	      		$mergeTable = $mergeTable."`".$CacheTable."`, ";
	    	}
	  	}
	
	  	$mergeTable = $mergeTable." ".$table_cache." );";
	
	  	$pear_syslogDB->query($mergeTable);
	  	if (PEAR::isError($pear_syslogDB)) {
	    	print "Mysql Error : ".$pear_syslogDB->getMessage();
	  	}
	
	  	$pear_syslogDB->query("FLUSH TABLES");
	  	if (PEAR::isError($pear_syslogDB)) {
	   		print "Mysql Error : ".$pear_syslogDB->getMessage();
	  	}
	}

	## MAIN
	print "BEGIN RELOAD CACHE AT ".date("Y-m-d H:i:s")."\n";
	$pear_syslogDB = getSyslogParameters();
	createTemporaryTable();
	instertCache();
	createCacheTable();
	mergeAllCache();
	print "END OF RELOAD CACHE AT ".date("Y-m-d H:i:s")."\n";
	print "\n";
?>
