#!/usr/bin/php
<?php
/*
 * Copyright 2005-2009 MERETHIS
 * Centreon is developped by : Julien Mathis and Romain Le Merlus under
 * GPL Licence 2.0.
 * 
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the GNU General Public License as published by the Free Software 
 * Foundation ; either version 2 of the License.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A 
 * PARTICULAR PURPOSE. See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, see <http://www.gnu.org/licenses>.
 * 
 * Linking this program statically or dynamically with other modules is making a 
 * combined work based on this program. Thus, the terms and conditions of the GNU 
 * General Public License cover the whole combination.
 * 
 * As a special exception, the copyright holders of this program give MERETHIS 
 * permission to link this program with independent modules to produce an executable, 
 * regardless of the license terms of these independent modules, and to copy and 
 * distribute the resulting executable under terms of MERETHIS choice, provided that 
 * MERETHIS also meet, for each linked independent module, the terms  and conditions 
 * of the license of that module. An independent module is a module which is not 
 * derived from this program. If you modify this program, you may extend this 
 * exception to your version of the program, but you are not obliged to do so. If you
 * do not wish to do so, delete this exception statement from your version.
 * 
 * For more information : contact@centreon.com
 * 
 * Module name: Syslog
 * 
 * Adaptation for Centreon 2.0 by : Merethis team 
 * 
 * SVN : $URL
 * SVN : $Id$
 * 
 */
 
	include 'DBconnect.php';

	function getLogsTables() {
		global $pear_syslogDB, $syslogOpt, $logsTables;

		$res =& $pear_syslogDB->query("SHOW TABLES;");
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}

		if ($res->numRows()){
			while($row = $res->fetchRow()) {
				if (strstr($row["Tables_in_syslog"], "logs")) {
					$logsTables[$row["Tables_in_syslog"]] = $row["Tables_in_syslog"];
				}
			}
		}
		return $logsTables;
	}
	
	function dropOldTables() {
		global $pear_syslogDB, $syslogOpt, $logsTables;
		
		$iMaxDay = $syslogOpt["syslog_db_rotate"]-1;
		
		$maxDay = "logs".date("Ymd",mktime(0,0,0,date("n"),(date("j")-$iMaxDay),date("Y")));
		
		foreach ($logsTables as $logTable) {
			if (strcmp($logTable, $maxDay) < 0) {
				if (strcmp($logTable, "logs") > 0) {
					$pear_syslogDB->query("DROP TABLE ".$logTable." ;");
					if (PEAR::isError($pear_syslogDB)) {
						print "Mysql Error : ".$pear_syslogDB->getMessage();
					}
					print "DROP TABLE ".$logTable."\n";
				}
			}
		}
	}
	
	function archiveTodayLogs() {
		global $pear_syslogDB, $syslogOpt;
		
		$today = date("Ymd",mktime(0,0,0,date("n"),date("j")+1,date("Y")));
		
		$pear_syslogDB->query("RENAME TABLE logs TO logs".$today.";");
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}
		else {
			print "RENAME TABLE logs TO logs".$today."\n";
		}
		
		$newTable = "CREATE TABLE `".$syslogOpt["syslog_db"]."`.`logs` (";
		$newTable = $newTable." host varchar(128) default NULL,";
		$newTable = $newTable." facility varchar(10) default NULL,";
		$newTable = $newTable." priority varchar(10) default NULL,";
		$newTable = $newTable." level varchar(10) default NULL,";
		$newTable = $newTable." tag varchar(10) default NULL,";
		$newTable = $newTable." datetime datetime default NULL,";
		$newTable = $newTable." program varchar(15) default NULL,";
		$newTable = $newTable." msg text,";
		$newTable = $newTable." seq bigint(20) unsigned NOT NULL auto_increment,";
		$newTable = $newTable." counter int(11) NOT NULL default '1',";
		$newTable = $newTable." fo datetime default NULL,";
		$newTable = $newTable." lo datetime default NULL,";
		$newTable = $newTable." PRIMARY KEY  (seq),";
		$newTable = $newTable." KEY datetime (datetime),";
		$newTable = $newTable." KEY priority (priority),";
		$newTable = $newTable." KEY facility (facility),";
		$newTable = $newTable." KEY program (program),";
		$newTable = $newTable." KEY host (host),";
		$newTable = $newTable." KEY host_datetime (host,datetime)";
		$newTable = $newTable." ) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci;";
		
		$pear_syslogDB->query($newTable);
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}
		else {
			print "CREATE TABLE logs\n";
		}
		
		$pear_syslogDB->query("FLUSH TABLES");
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}
	}
	
	function mergeAllLogs() {
		global $pear_syslogDB, $syslogOpt;
		
		$pear_syslogDB->query("DROP TABLE `".$syslogOpt["syslog_db"]."`.`all_logs`;");
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}
		else {
			print "DROP TABLE all_logs\n";
		}
		
		$mergeTable = "CREATE TABLE `".$syslogOpt["syslog_db"]."`.`all_logs` (";
		$mergeTable = $mergeTable." `host` varchar(128) collate utf8_unicode_ci default NULL,";
		$mergeTable = $mergeTable." `facility` varchar(10) collate utf8_unicode_ci default NULL,";
		$mergeTable = $mergeTable." `priority` varchar(10) collate utf8_unicode_ci default NULL,";
		$mergeTable = $mergeTable." `level` varchar(10) collate utf8_unicode_ci default NULL,";
		$mergeTable = $mergeTable." `tag` varchar(10) collate utf8_unicode_ci default NULL,";
		$mergeTable = $mergeTable." `datetime` datetime default NULL,";
		$mergeTable = $mergeTable." `program` varchar(15) collate utf8_unicode_ci default NULL,";
		$mergeTable = $mergeTable." `msg` text collate utf8_unicode_ci,";
		$mergeTable = $mergeTable." `seq` bigint(20) unsigned NOT NULL auto_increment,";
		$mergeTable = $mergeTable." `counter` int(11) NOT NULL default '1',";
		$mergeTable = $mergeTable." `fo` datetime default NULL,";
		$mergeTable = $mergeTable." `lo` datetime default NULL,";
		$mergeTable = $mergeTable." PRIMARY KEY  (`seq`),";
		$mergeTable = $mergeTable." KEY `datetime` (`datetime`),";
		$mergeTable = $mergeTable." KEY `priority` (`priority`),";
		$mergeTable = $mergeTable." KEY `facility` (`facility`),";
		$mergeTable = $mergeTable." KEY `program` (`program`),";
		$mergeTable = $mergeTable." KEY `host` (`host`),";
		$mergeTable = $mergeTable." KEY `host_datetime` (`host`,`datetime`)";
		$mergeTable = $mergeTable." ) ENGINE=MRG_MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci UNION=(";

		$logsTables = getLogsTables();
		foreach ($logsTables as $logTable) {
			if (strcmp($logTable, "logs") > 0) {
				$mergeTable = $mergeTable."`".$logTable."`, ";
			}
		}

		$mergeTable = $mergeTable." `logs`);";
		
		$pear_syslogDB->query($mergeTable);
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}
		else {
			print "CREATE MERGE TABLE all_logs\n";
		}

		$pear_syslogDB->query("FLUSH TABLES");
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}
	}

	function getCacheTables() {
		global $pear_syslogDB, $syslogOpt, $cacheTables;

		$res =& $pear_syslogDB->query("SHOW TABLES;");
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}

		if ($res->numRows()){
			while($row = $res->fetchRow()) {
				if (strstr($row["Tables_in_syslog"], "cache")) {
					$cacheTables[$row["Tables_in_syslog"]] = $row["Tables_in_syslog"];
				}
			}
		}
		return $cacheTables;
	}

	function archiveTodayCache() {
		global $pear_syslogDB, $syslogOpt;
		
		$today = date("Ymd",mktime(0,0,0,date("n"),date("j")+1,date("Y")));
		
		$pear_syslogDB->query("RENAME TABLE cache TO cache".$today.";");
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}
		else {
			print "RENAME TABLE cache TO cache".$today."\n";
		}
	}
	
	function dropOldTablesCache() {
		global $pear_syslogDB, $syslogOpt, $cacheTables;
		
		$iMaxDay = $syslogOpt["syslog_db_rotate"]-1;
		
		$maxDay = "cache".date("Ymd",mktime(0,0,0,date("n"),(date("j")-$iMaxDay),date("Y")));
		
		foreach ($cacheTables as $cacheTable) {
			if (strcmp($cacheTable, $maxDay) < 0) {
				if (strcmp($cacheTable, "cache") > 0) {
					$pear_syslogDB->query("DROP TABLE ".$cacheTable." ;");
					if (PEAR::isError($pear_syslogDB)) {
						print "Mysql Error : ".$pear_syslogDB->getMessage();
					}
					print "DROP TABLE ".$cacheTable."\n";
				}
			}
		}
	}
		
	function mergeAllCache() {
		global $pear_syslogDB, $syslogOpt;
  
		$pear_syslogDB->query("DROP TABLE `".$syslogOpt["syslog_db"]."`.`all_cache`;");
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}
		else {
			print "DROP TABLE all_cache\n";
		}
  
		$mergeTable = "CREATE TABLE `".$syslogOpt["syslog_db"]."`.`all_cache` (";
		$mergeTable = $mergeTable . "`type` enum('HOST','FACILITY','PROGRAM','PRIORITY', 'TAG') collate utf8_unicode_ci default NULL,";
		$mergeTable = $mergeTable . "`value` varchar(50) collate utf8_unicode_ci default NULL";
		$mergeTable = $mergeTable . ") ENGINE=MRG_MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci UNION=(";
  
		$CacheTables = getCacheTables();
  
		foreach ($CacheTables as $CacheTable) {
			if (strcmp($CacheTable, "cache") > 0) {
				$mergeTable = $mergeTable."`".$CacheTable."`, ";
			}
		}

		$mergeTable = $mergeTable." `cache`);";
  
		$pear_syslogDB->query($mergeTable);
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}
		else {
			print "CREATE MERGE TABLE all_cache\n";
		}
  
		$pear_syslogDB->query("FLUSH TABLES");
		if (PEAR::isError($pear_syslogDB)) {
			print "Mysql Error : ".$pear_syslogDB->getMessage();
		}
	}
	
	## MAIN
	print "BEGIN TABLES LOGS ROTATION AT ".date("Y-m-d H:i:s")."\n";
	$pear_syslogDB = getSyslogParameters();
	$logsTables = getLogsTables();
	archiveTodayLogs();
	dropOldTables();
	mergeAllLogs();
	print "END OF TABLES LOGS ROTATION AT ".date("Y-m-d H:i:s")."\n";
	
	print "BEGIN TABLES CACHE ROTATION AT ".date("Y-m-d H:i:s")."\n";
    $cacheTables = getCacheTables();
    archiveTodayCache();
	dropOldTablesCache();
	mergeAllCache();
	print "END OF TABLES CACHE ROTATION AT ".date("Y-m-d H:i:s")."\n";
 ?>